



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>从 JavaScript 到 TypeScript</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">从 JavaScript 到 TypeScript</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 14:30:12 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<blockquote><p>本文首发在我的个人博客：<a href="http://muyunyun.cn/posts/66a54fc2/" rel="external nofollow noreferrer">http://muyunyun.cn/posts/66a54fc2/</a><br /><br />
文中的案例代码已经上传到 <a href="https://github.com/MuYunyun/TypeScript" rel="external nofollow noreferrer">TypeScript</a></p></blockquote>
<p>TypeScript 并不是一个完全新的语言, 它是 JavaScript 的超集，为 JavaScript 的生态增加了类型机制，并最终将代码编译为纯粹的 JavaScript 代码。</p>
<h4>TypeScript 简介</h4>
<p>TypeScript 由 Microsoft(算上 Angular 2 的话加上 Google)开发和维护的一种开源编程语言。 它支持 JavaScript 的所有语法和语义，同时通过作为 ECMAScript 的超集来提供一些额外的功能，如类型检测和更丰富的语法。下图显示了 TypeScript 与 ES5，ES2015，ES2016 之间的关系。</p>
<p><img referrerpolicy="no-referrer"src="http://oqhtscus0.bkt.clouddn.com/da62039bf146c2ebd615ef1d11a1a808.jpg"></p>
<h4>使用 TypeScript 的原因</h4>
<p>JavaScript 是一门弱类型语言，变量的数据类型具有动态性，只有执行时才能确定变量的类型，这种后知后觉的认错方法会让开发者成为调试大师，但无益于编程能力的提升，还会降低开发效率。TypeScript 的类型机制可以有效杜绝由变量类型引起的误用问题，而且开发者可以控制对类型的监控程度，是严格限制变量类型还是宽松限制变量类型，都取决于开发者的开发需求。添加类型机制之后，副作用主要有两个：增大了开发人员的学习曲线，增加了设定类型的开发时间。总体而言，这些付出相对于代码的健壮性和可维护性，都是值得的。</p>
<p>此外，类型注释是 TypeScript 的内置功能之一，允许文本编辑器和 IDE 可以对我们的代码执行更好的静态分析。 这意味着我们可以通过自动编译工具的帮助，在编写代码时减少错误，从而提高我们的生产力。</p>
<p>对 TypeScript 的简介到此，接下来对其特有的知识点进行简单概括总结，(网上很多教程实际上把 ES6， ES7 的知识点也算进 ts 的知识点了，当然这没错~)</p>
<h4>数据类型</h4>
<h5>String 类型</h5>
<p>一个保存字符串的文本，类型声明为 string。可以发现类型声明可大写也可小写，后文同理。</p>
<pre class="prettyprint linenums"><code>let name: string = 'muyy'<br />
let name2: String = 'muyy'<br />
</code></pre>
<h5>Boolen 类型</h5>
<p>boolean是 true 或 false 的值，所以 <code>let isBool3: boolean = new Boolean(1)</code> 就会编译报错，因为 new Boolean(1) 生成的是一个 Bool 对象。</p>
<pre class="prettyprint linenums"><code>let isBool1: boolean = false<br />
</code></pre>
<h5>Number 类型</h5>
<pre class="prettyprint linenums"><code>let number: number = 10;<br />
</code></pre>
<h5>Array 类型</h5>
<p>数组是 Array 类型。然而，因为数组是一个集合，我们还需要指定在数组中的元素的类型。我们通过 <code>Array&lt;type&gt;</code> or <code>type[]</code> 语法为数组内的元素指定类型</p>
<pre class="prettyprint linenums"><code>let arr:number[] = [1, 2, 3, 4, 5];<br />
let arr2:Array&lt;number&gt; = [1, 2, 3, 4, 5];

let arr3:string[] = [&quot;1&quot;,&quot;2&quot;];<br />
let arr4:Array&lt;string&gt; = [&quot;1&quot;,&quot;2&quot;];<br />
</code></pre>
<h5>Enums 类型</h5>
<p>列出所有可用值，一个枚举的默认初始值是0。你可以调整一开始的范围：</p>
<pre class="prettyprint linenums"><code>enum Role {Employee = 3, Manager, Admin}<br />
let role: Role = Role.Employee<br />
console.log(role) // 3<br />
</code></pre>
<h5>Any 类型</h5>
<p>any 是默认的类型，其类型的变量允许任何类型的值：</p>
<pre class="prettyprint linenums"><code>let notSure:any = 10;<br />
let notSure2:any[] = [1,&quot;2&quot;,false];<br />
</code></pre>
<h5>Void 类型</h5>
<p>JavaScript 没有空值 Void 的概念，在 TypeScirpt 中，可以用 void 表示没有任何返回值的函数：</p>
<pre class="prettyprint linenums"><code>function alertName(): void {<br />
  console.log('My name is muyy')<br />
}<br />
</code></pre>
<h4>函数</h4>
<h5>为函数定义类型</h5>
<p>我们可以给每个参数添加类型之后再为函数本身添加返回值类型。 TypeScript能够根据返回语句自动推断出返回值类型，因此我们通常省略它。下面函数 add, add2, add3 的效果是一样的，其中是 add3 函数是函数完整类型。</p>
<pre class="prettyprint linenums"><code>function add(x: string, y: string): string{<br />
    return &quot;Hello TypeScript&quot;;<br />
}

let add2 = function(x: string, y: string): string{<br />
    return &quot;Hello TypeScript&quot;;<br />
}

let add3: (x: string, y: string) =&gt; string = function(x: string, y: string): string{<br />
    return &quot;Hello TypeScript&quot;;<br />
}<br />
</code></pre>
<h5>可选参数和默认参数</h5>
<p>JavaScript 里，每个参数都是可选的，可传可不传。 没传参的时候，它的值就是 undefined 。 在 TypeScript 里我们可以在参数名旁使用?实现可选参数的功能。 比如，我们想让 lastname 是可选的：</p>
<pre class="prettyprint linenums"><code>function buildName(firstName: string, lastname?: string){<br />
    console.log(lastname ? firstName + &quot;&quot; + lastname : firstName)<br />
}

let res1 = buildName(&quot;鸣&quot;,&quot;人&quot;); // 鸣人<br />
let res2 = buildName(&quot;鸣&quot;); // 鸣<br />
let res3 = buildName(&quot;鸣&quot;, &quot;人&quot;, &quot;君&quot;); // Supplied parameters do not match any signature of call target.<br />
</code></pre>
<p>如果带默认值的参数出现在必须参数前面，用户必须明确的传入 undefined 值来获得默认值。 例如，我们重写上例子，让 firstName 是带默认值的参数：</p>
<pre class="prettyprint linenums"><code>function buildName2(firstName = &quot;鸣&quot;, lastName?: string){<br />
    console.log(firstName + &quot;&quot; + lastName)<br />
}

let res4 = buildName2(&quot;人&quot;); // undefined人<br />
let res5 = buildName2(undefined, &quot;人&quot;); // 鸣人<br />
</code></pre>
<h4>类</h4>
<p>传统的JavaScript程序使用函数和基于原型的继承来创建可重用的组件，但对于熟悉使用面向对象方式的程序员来讲就有些棘手，因为他们用的是基于类的继承并且对象是由类构建出来的。 从ECMAScript 2015，也就是ECMAScript 6开始，JavaScript程序员将能够使用基于类的面向对象的方式。 使用TypeScript，我们允许开发者现在就使用这些特性，并且编译后的JavaScript可以在所有主流浏览器和平台上运行，而不需要等到下个JavaScript版本。</p>
<h5>类</h5>
<pre class="prettyprint linenums"><code>class Person{<br />
    name:string; // 这个是对后文this.name类型的定义<br />
    age:number;<br />
    constructor(name:string,age:number){<br />
        this.name = name;<br />
        this.age = age;<br />
    }<br />
    print(){<br />
        return this.name + this.age;<br />
    }<br />
}

let person:Person = new Person('muyy',23)<br />
console.log(person.print()) // muyy23<br />
</code></pre>
<p>我们在引用任何一个类成员的时候都用了 this。 它表示我们访问的是类的成员。其实这本质上还是 ES6 的知识，只是在 ES6 的基础上多上了对 this 字段和引用参数的类型声明。</p>
<h5>继承</h5>
<pre class="prettyprint linenums"><code>class Person{<br />
    public name:string;  // public、private、static 是 typescript 中的类访问修饰符<br />
    age:number;<br />
    constructor(name:string,age:number){<br />
        this.name = name;<br />
        this.age = age;<br />
    }<br />
    tell(){<br />
        console.log(this.name + this.age);<br />
    }<br />
}

class Student extends Person{<br />
    gender:string;<br />
    constructor(gender:string){<br />
        super(&quot;muyy&quot;,23);<br />
        this.gender = gender;<br />
    }<br />
    tell(){<br />
        console.log(this.name + this.age + this.gender);<br />
    }<br />
}

var student = new Student(&quot;male&quot;);<br />
student.tell();  // muyy23male<br />
</code></pre>
<p>这个例子展示了 TypeScript 中继承的一些特征，可以看到其实也是 ES6 的知识上加上类型声明。不过这里多了一个知识点 —— 公共，私有，以及受保护的修饰符。TypeScript 里，成员默认为 public ；当成员被标记成 private 时，它就不能在声明它的类的外部访问；protected 修饰符与private 修饰符的行为很相似，但有一点不同，protected 成员在派生类中仍然可以访问。</p>
<h5>存储器</h5>
<p>TypeScript 支持通过 getters/setters 来截取对对象成员的访问。 它能帮助你有效的控制对对象成员的访问。</p>
<p>对于存取器有下面几点需要注意的：<br /><br />
首先，存取器要求你将编译器设置为输出 ECMAScript 5 或更高。 不支持降级到 ECMAScript 3。 其次，只带有 get 不带有 set 的存取器自动被推断为 readonly。 这在从代码生成 .d.ts 文件时是有帮助的，因为利用这个属性的用户会看到不允许够改变它的值。</p>
<pre class="prettyprint linenums"><code>class Hello{<br />
    private _name: string;<br />
    private _age: number;<br />
    get name(): string {<br />
        return this._name;<br />
    }<br />
    set name(value: string) {<br />
        this._name = value;<br />
    }<br />
    get age(): number{<br />
        return this._age;<br />
    }<br />
    set age(age: number) {<br />
        if(age&gt;0 &amp;&amp; age&lt;100){<br />
            console.log(&quot;年龄在0-100之间&quot;); // 年龄在0-100之间<br />
            return;<br />
        }<br />
        this._age = age;<br />
    }<br />
}

let hello = new Hello();<br />
hello.name = &quot;muyy&quot;;<br />
hello.age = 23<br />
console.log(hello.name); // muyy<br />
</code></pre>
<h4>接口</h4>
<h5>接口</h5>
<p>TypeScript的核心原则之一是对值所具有的结构进行类型检查。在TypeScript里，接口的作用就是为这些类型命名和为你的代码或第三方代码定义契约。</p>
<pre class="prettyprint linenums"><code>interface LabelValue{<br />
    label: string;<br />
}

function printLabel(labelObj: LabelValue){<br />
    console.log(labelObj.label);<br />
}

let myObj = {<br />
    &quot;label&quot;:&quot;hello Interface&quot;<br />
};<br />
printLabel(myObj);<br />
</code></pre>
<p>LabelledValue 接口就好比一个名字，它代表了有一个 label 属性且类型为 string 的对象。只要传入的对象满足上述必要条件，那么它就是被允许的。</p>
<p>另外，类型检查器不会去检查属性的顺序，只要相应的属性存在并且类型也是对的就可以。</p>
<h5>可选属性</h5>
<p>带有可选属性的接口与普通的接口定义差不多，只是在可选属性名字定义的后面加一个 ? 符号。可选属性的好处之一是可以对可能存在的属性进行预定义，好处之二是可以捕获引用了不存在的属性时的错误。</p>
<pre class="prettyprint linenums"><code>interface Person{<br />
    name?:string;<br />
    age?:number;<br />
}

function printInfo(info:Person){<br />
    console.log(info);<br />
}

let info = {<br />
    &quot;name&quot;:&quot;muyy&quot;,<br />
    &quot;age&quot;:23<br />
};

printInfo(info); // {&quot;name&quot;: &quot;muyy&quot;, &quot;age&quot;: 23}

let info2 = {<br />
    &quot;name&quot;:&quot;muyy&quot;<br />
};

printInfo(info2); // {&quot;name&quot;: &quot;muyy&quot;}<br />
</code></pre>
<h5>函数类型</h5>
<p>接口能够描述 JavaScript 中对象拥有的各种各样的外形。 除了描述带有属性的普通对象外，接口也可以描述函数类型。定义的函数类型接口就像是一个只有参数列表和返回值类型的函数定义。参数列表里的每个参数都需要名字和类型。定义后完成后，我们可以像使用其它接口一样使用这个函数类型的接口。</p>
<pre class="prettyprint linenums"><code>interface SearchFunc{<br />
    (source: string, subString: string): boolean;<br />
}

let mySearch: SearchFunc;<br />
mySearch = function(source: string,subString: string){<br />
    return source.search(subString) !== -1;<br />
};

console.log(mySearch(&quot;鸣人&quot;,&quot;鸣&quot;)); // true<br />
console.log(mySearch(&quot;鸣人&quot;,&quot;缨&quot;)); // false<br />
</code></pre>
<h5>可索引类型</h5>
<p>与使用接口描述函数类型差不多，我们也可以描述那些能够“通过索引得到”的类型，比如 <code>a[10]</code> 或 <code>ageMap[&quot;daniel&quot;]</code>。 可索引类型具有一个索引签名，它描述了对象索引的类型，还有相应的索引返回值类型。 让我们看如下例子：</p>
<pre class="prettyprint linenums"><code>interface StringArray{<br />
    [index: number]: string;<br />
}

let MyArray: StringArray;<br />
MyArray = [&quot;是&quot;,&quot;云&quot;,&quot;随&quot;,&quot;风&quot;];<br />
console.log(MyArray[2]); // 随<br />
</code></pre>
<h5>类类型</h5>
<p>与 C# 或 Java 里接口的基本作用一样，TypeScript 也能够用它来明确的强制一个类去符合某种契约。</p>
<p>我们可以在接口中描述一个方法，在类里实现它，如同下面的 <code>setTime</code> 方法一样：</p>
<pre class="prettyprint linenums"><code>interface ClockInterface{<br />
    currentTime: Date;<br />
    setTime(d: Date);<br />
}

class Clock implements ClockInterface{<br />
    currentTime: Date;<br />
    setTime(d: Date){<br />
        this.currentTime = d;<br />
    }<br />
    constructor(h: number, m: number) {}<br />
}<br />
</code></pre>
<h5>继承接口</h5>
<p>和类一样，接口也可以相互继承。 这让我们能够从一个接口里复制成员到另一个接口里，可以更灵活地将接口分割到可重用的模块里。</p>
<pre class="prettyprint linenums"><code>interface Shape{<br />
    color: string;<br />
}

interface PenStroke{<br />
    penWidth: number;<br />
}

interface Square extends Shape,PenStroke{<br />
    sideLength: number;<br />
}

let s = &lt;Square&gt;{};<br />
s.color = &quot;blue&quot;;<br />
s.penWidth = 100;<br />
s.sideLength = 10;<br />
</code></pre>
<h4>模块</h4>
<p>TypeScript 与 ECMAScript 2015 一样，任何包含顶级 import 或者 export 的文件都被当成一个模块。</p>
<pre class="prettyprint linenums"><code>export interface StringValidator{<br />
    isAcceptable(s:string): boolean;<br />
}

var strReg = /^[A-Za-z]+$/;<br />
var numReg = /^[0-9]+$/;

export class letterValidator implements StringValidator{<br />
    isAcceptable(s:string): boolean{<br />
        return strReg.test(s);<br />
    }<br />
}

export class zipCode implements StringValidator{<br />
    isAcceptable(s: string): boolean{<br />
        return s.length == 5 &amp;&amp; numReg.test(s);<br />
    }<br />
}<br />
</code></pre>
<h4>泛型</h4>
<p>软件工程中，我们不仅要创建一致的定义良好的 API ，同时也要考虑可重用性。 组件不仅能够支持当前的数据类型，同时也能支持未来的数据类型，这在创建大型系统时为你提供了十分灵活的功能。<br /><br />
在像 C# 和 Java 这样的语言中，可以使用泛型来创建可重用的组件，一个组件可以支持多种类型的数据。 这样用户就可以以自己的数据类型来使用组件。</p>
<h5>初探泛型</h5>
<p>如下代码，我们给 Hello 函数添加了类型变量 T ，T 帮助我们捕获用户传入的类型（比如：string）。我们把这个版本的 Hello 函数叫做泛型，因为它可以适用于多个类型。 代码中 <code>output</code> 和 <code>output2</code> 是效果是相同的，第二种方法更加普遍，利用了类型推论 —— 即编译器会根据传入的参数自动地帮助我们确定T的类型：</p>
<pre class="prettyprint linenums"><code>function Hello&lt;T&gt;(arg:T):T{<br />
    return arg;<br />
}

let outPut = Hello&lt;string&gt;('Hello Generic');<br />
let output2 = Hello('Hello Generic')

console.log(outPut);<br />
console.log(outPut2);<br />
</code></pre>
<h4>参考资料</h4>
<ul><li><a href="https://www.gitbook.com/book/zhongsp/typescript-handbook/details" rel="external nofollow noreferrer">TypeScript 中文文档</a></li>
<li><a href="http://pinggod.com/2016/Typescript/" rel="external nofollow noreferrer">TypeScript</a></li>
<li><a href="http://naywinmyint.com/typescript-for-angular-2-part-1/" rel="external nofollow noreferrer">TypeScript for Angular 2 - Part 1 (An Introduction)</a></li></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwl37r9.html">每个程序员都会的35个jQuery小技巧！</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvnloj9.html">centos 网络配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnkxogq.html">ui router 介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxm00e9.html">PRD</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvympyq.html">利用破解dll来获取到一个软件的注册码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm5v4x9.html">angularJs中图表功能（有集成框架）－angular-flot</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1p4on9.html">hdu2073递推题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydpg2mq.html">Android Permissions管理之用户拒绝授权</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge1g5e8.html">poj 1979 Red and Black&lpar;dfs&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8med000q.html">Android消息提示框Toast</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kly409.html">OpenCV探索之路（五）：图片缩放和图像金字塔</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge2dk48.html">【Java基础】【12String类】</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mzon38.html">JavaScript 面向对象之原型对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpw6or9.html">luogu P5294 &lbrack;HNOI2019&rsqb;序列</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o11xjpq.html">【Java每日一题】20170324</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gpvoeq.html">Volatile的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw2lp09.html">Build Tool（构建工具）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4z0dz9.html">Ubuntu 14&period;10 下ZooKeeper&plus;Hadoop2&period;6&period;0&plus;HBase1&period;0&period;0 的HA机群高可用配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/96307049.html">Arduino驱动无源蜂鸣器发声</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql17xxk9.html">批量替换url，指定内容不替换</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv1rk3zq.html">Python数据类型之变量</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mewywoq.html">python 之变量</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjr4nr8.html">4、Swing在JPanel中添加背景图片方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/950w7o08.html">《安卓网络编程》之第七篇  java编写Service程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zk3e59.html">swift学习 - 计时器</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mpny48.html">GitBook 使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg136m8.html">RavenDB FS 安装使用 介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pynj38.html">MySQL 开启慢查询日志</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo47gdq.html">利用Dockerfile构建mysql镜像并实现数据的初始化及权限设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pyn2v8.html">&period;net&mdash;&mdash; webservice的新建、发布、使用（最全、最简单）【原创】</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
